import java.awt.*;
import java.awt.event.*;
//import java.applet.*;
import java.io.*;
import java.util.*;
 
 
public class jacoInputs extends Panel implements 
             ItemListener, AdjustmentListener {

  jacobi outerparent;

  GridBagLayout gbl;
  GridBagConstraints gbc;  

  static public Label jLabel;  
  static public Label gridsLabel;    static public TextField gridsTxt;
  static public Label colorLabel;    static public Choice colorChoice;
  static public Label sizeLabel;     static public Choice sizeChoice;
  static public Label timesLabel;    static public TextField timesTxt;
  static public Scrollbar timesScroll;
  static int max = 10000;

  ////////////////////////////////////////////////////////////  
  private void add(Component c, GridBagLayout gbl,
		   GridBagConstraints gbc, 
                   int x, int y, int w, int h) {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gbl.setConstraints(c,gbc);
    add(c);
  }
  ////////////////////////////////////////////////////////////
  public void paint(Graphics g) {
    Dimension d = getSize();
    Insets in = getInsets();
 
    g.drawRect(2, 2, d.width-6, d.height-6);
 
  }
  ////////////////////////////////////////////////////////////
  public Insets getInsets() {
    return new Insets(10,10,10,10);
  }

  ////////////////////////////////////////////////////////////
  public void adjustmentValueChanged(AdjustmentEvent evt) {
      if(evt.getSource() == timesScroll) {
		timesTxt.setText(Integer.toString((int)timesScroll.getValue()));
		this.outerparent.update();
      }
  }


  ////////////////////////////////////////////////////////////
  public void itemStateChanged(ItemEvent ievt) {
    if(ievt.getStateChange() == ItemEvent.SELECTED) {
      if(ievt.getSource() == colorChoice) {
		 int clrIdx = Integer.valueOf(colorChoice.getSelectedItem()).intValue();
      }
      else if(ievt.getSource() == sizeChoice) {
		int gsize = Integer.valueOf(sizeChoice.getSelectedItem()).intValue();
      }
      this.outerparent.update();
    }
  }


  ////////////////////////////////////////////////////////////
  public jacoInputs(jacobi target) {

    this.outerparent = target;

    gbl = new GridBagLayout();
    setLayout(gbl);
    
    jLabel = new Label("Jacobi Iteration demo: Java  version",Label.CENTER);
    jLabel.setFont(new Font("TimesRoman", Font.BOLD, 18));
    jLabel.setBackground(Color.yellow);
    jLabel.setForeground(Color.blue);
 
    setFont(new Font("Helvetica", Font.PLAIN, 12));

    gridsLabel = new Label("Grids",Label.RIGHT);
    gridsTxt = new TextField(2);
    gridsTxt.setText(Integer.toString(jacobi.n));
    gridsTxt.setEditable(false);

    colorLabel = new Label("Color :",Label.RIGHT);
    colorChoice = new Choice();
    colorChoice.addItem("Red");
    colorChoice.addItem("Green");
    colorChoice.addItem("Blue");
    colorChoice.addItemListener(this);
 
    sizeLabel = new Label("Size",Label.RIGHT);
    sizeChoice = new Choice();
    sizeChoice.addItem("8");
    sizeChoice.addItem("16");
    sizeChoice.addItem("32");
    sizeChoice.addItem("64");
    sizeChoice.addItemListener(this);

    timesLabel = new Label("Iteration Times :",Label.RIGHT);
    timesTxt = new TextField("20",8);
    timesScroll = new Scrollbar(Scrollbar.HORIZONTAL,0,0,0,max);
    timesScroll.setValue(20);
    timesScroll.setBlockIncrement(10);
    timesScroll.setUnitIncrement(10);
    timesScroll.addAdjustmentListener(this);
    
    Label blankLabel = new Label(" ");     
    
    gbc = new GridBagConstraints();
    gbc.fill = GridBagConstraints.HORIZONTAL;
    gbc.weightx = 20;
    gbc.weighty = 100;
    gbc.ipadx = 1;
    gbc.ipady = 1;
    
    add(jLabel,  gbl, gbc, 1, 1, 7, 1);

    add(gridsLabel,  gbl, gbc, 1, 2, 1, 1);
    add(gridsTxt,    gbl, gbc, 2, 2, 1, 1);

    add(colorLabel,  gbl, gbc, 1, 3, 1, 1);
    add(colorChoice, gbl, gbc, 2, 3, 1, 1);

    add(sizeLabel,   gbl, gbc, 3, 2, 1, 1);
    add(sizeChoice,  gbl, gbc, 4, 2, 1, 1);

    add(timesLabel,  gbl, gbc, 3, 3, 1, 1);
    add(timesTxt,    gbl, gbc, 4, 3, 1, 1);
	add(timesScroll, gbl, gbc, 4, 4, 1, 1);

    ////////////////////////////////////////////
    // add(betaLabel,    gbl, gbc, 5, 2, 1, 1);
    // add(betaTxt,      gbl, gbc, 6, 2, 1, 1);
    // add(betaScroll,   gbl, gbc, 7, 2, 1, 1);
    ////////////////////////////////////////////
  }
}  
